Index: branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limthd_ent.F90
===================================================================
--- branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limthd_ent.F90	(revision 3614)
+++ branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limthd_ent.F90	(revision 3625)
@@ -16,17 +16,18 @@
    !!   'key_lim3'                                      LIM3 sea-ice model
    !!----------------------------------------------------------------------
-   !!   lim_thd_ent : ice redistribution of enthalpy
+   !!   lim_thd_ent   : ice redistribution of enthalpy
    !!----------------------------------------------------------------------
-   USE par_oce          ! ocean parameters
-   USE dom_oce          ! domain variables
-   USE domain           !
-   USE phycst           ! physical constants
-   USE ice              ! LIM variables
-   USE par_ice          ! LIM parameters
-   USE thd_ice          ! LIM thermodynamics
-   USE limvar           ! LIM variables
-   USE in_out_manager   ! I/O manager
-   USE lib_mpp          ! MPP library
-   USE wrk_nemo         ! work arrays
+   USE par_oce        ! ocean parameters
+   USE dom_oce        ! domain variables
+   USE domain         !
+   USE phycst         ! physical constants
+   USE ice            ! LIM variables
+   USE par_ice        ! LIM parameters
+   USE thd_ice        ! LIM thermodynamics
+   USE limvar         ! LIM variables
+   USE in_out_manager ! I/O manager
+   USE lib_mpp        ! MPP library
+   USE wrk_nemo       ! work arrays
+   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
    IMPLICIT NONE
@@ -43,5 +44,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/LIM3 3.4 , UCL - NEMO Consortium (2011)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -408,13 +409,13 @@
       IF ( con_i ) THEN
          DO ji = kideb, kiut
-            IF ( ABS ( zqts_in(ji) - zqts_fin(ji) ) / rdt_ice .GT. 1.0e-6 ) THEN
+            IF ( ABS ( zqts_in(ji) - zqts_fin(ji) ) * r1_rdtice  >  1.0e-6 ) THEN
                zji                 = MOD( npb(ji) - 1, jpi ) + 1
                zjj                 = ( npb(ji) - 1 ) / jpi + 1
                WRITE(numout,*) ' violation of heat conservation : ',             &
-                  ABS ( zqts_in(ji) - zqts_fin(ji) ) / rdt_ice
+                  ABS ( zqts_in(ji) - zqts_fin(ji) ) * r1_rdtice
                WRITE(numout,*) ' ji, jj   : ', zji, zjj
                WRITE(numout,*) ' ht_s_b   : ', ht_s_b(ji)
-               WRITE(numout,*) ' zqts_in  : ', zqts_in(ji) / rdt_ice
-               WRITE(numout,*) ' zqts_fin : ', zqts_fin(ji) / rdt_ice
+               WRITE(numout,*) ' zqts_in  : ', zqts_in (ji) * r1_rdtice
+               WRITE(numout,*) ' zqts_fin : ', zqts_fin(ji) * r1_rdtice
                WRITE(numout,*) ' dh_snowice : ', dh_snowice(ji)
                WRITE(numout,*) ' dh_s_tot : ', dh_s_tot(ji)
@@ -526,5 +527,5 @@
          ! bottom formation temperature
          ztform = t_i_b(ji,nlay_i)
-         IF ( ( num_sal .EQ. 2 ) .OR. ( num_sal .EQ. 4 ) ) ztform = t_bo_b(ji)
+         IF(  num_sal == 2  )   ztform = t_bo_b(ji)
          qm0(ji,nbot0(ji)) = ( 1.0 - icboswi(ji) )*qm0(ji,nbot0(ji))             &   ! case of melting ice
             &              + icboswi(ji) * rhoic * ( cpic*(ztmelts-ztform)       &   ! case of forming ice
@@ -622,12 +623,12 @@
       !
       DO ji = kideb, kiut
-         IF ( ABS ( zqti_in(ji) - zqti_fin(ji) ) / rdt_ice .GT. 1.0e-6 ) THEN
+         IF ( ABS ( zqti_in(ji) - zqti_fin(ji) ) * r1_rdtice  >  1.0e-6 ) THEN
             zji                 = MOD( npb(ji) - 1, jpi ) + 1
             zjj                 = ( npb(ji) - 1 ) / jpi + 1
-            WRITE(numout,*) ' violation of heat conservation : ', ABS ( zqti_in(ji) - zqti_fin(ji) ) / rdt_ice
+            WRITE(numout,*) ' violation of heat conservation : ', ABS ( zqti_in(ji) - zqti_fin(ji) ) * r1_rdtice
             WRITE(numout,*) ' ji, jj   : ', zji, zjj
             WRITE(numout,*) ' ht_i_b   : ', ht_i_b(ji)
-            WRITE(numout,*) ' zqti_in  : ', zqti_in(ji) / rdt_ice
-            WRITE(numout,*) ' zqti_fin : ', zqti_fin(ji) / rdt_ice
+            WRITE(numout,*) ' zqti_in  : ', zqti_in (ji) * r1_rdtice
+            WRITE(numout,*) ' zqti_fin : ', zqti_fin(ji) * r1_rdtice
             WRITE(numout,*) ' dh_i_bott: ', dh_i_bott(ji)
             WRITE(numout,*) ' dh_i_surf: ', dh_i_surf(ji)
Index: branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limthd_lac.F90
===================================================================
--- branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limthd_lac.F90	(revision 3614)
+++ branches/2012/dev_NOC_2012_rev3555/NEMOGCM/NEMO/LIM_SRC_3/limthd_lac.F90	(revision 3625)
@@ -13,20 +13,21 @@
    !!   'key_lim3'                                      LIM3 sea-ice model
    !!----------------------------------------------------------------------
-   !!   lim_lat_acr    : lateral accretion of ice
-   !!----------------------------------------------------------------------
-   USE par_oce          ! ocean parameters
-   USE dom_oce          ! domain variables
-   USE phycst           ! physical constants
-   USE sbc_oce          ! Surface boundary condition: ocean fields
-   USE sbc_ice          ! Surface boundary condition: ice fields
-   USE thd_ice          ! LIM thermodynamics
-   USE dom_ice          ! LIM domain
-   USE par_ice          ! LIM parameters
-   USE ice              ! LIM variables
-   USE limtab           ! LIM 2D <==> 1D
-   USE limcons          ! LIM conservation
-   USE in_out_manager   ! I/O manager
-   USE lib_mpp          ! MPP library
-   USE wrk_nemo         ! work arrays
+   !!   lim_lat_acr   : lateral accretion of ice
+   !!----------------------------------------------------------------------
+   USE par_oce        ! ocean parameters
+   USE dom_oce        ! domain variables
+   USE phycst         ! physical constants
+   USE sbc_oce        ! Surface boundary condition: ocean fields
+   USE sbc_ice        ! Surface boundary condition: ice fields
+   USE thd_ice        ! LIM thermodynamics
+   USE dom_ice        ! LIM domain
+   USE par_ice        ! LIM parameters
+   USE ice            ! LIM variables
+   USE limtab         ! LIM 2D <==> 1D
+   USE limcons        ! LIM conservation
+   USE in_out_manager ! I/O manager
+   USE lib_mpp        ! MPP library
+   USE wrk_nemo       ! work arrays
+   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
    IMPLICIT NONE
@@ -45,5 +46,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/LIM3 3.4 , UCL - NEMO Consortium (2011)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -77,10 +78,11 @@
       !!               update ht_s_b, ht_i_b and tbif_1d(:,:)      
       !!------------------------------------------------------------------------
-      INTEGER ::   ji,jj,jk,jl,jm   ! dummy loop indices
-      INTEGER ::   layer, nbpac     ! local integers 
-      INTEGER ::   zji, zjj, iter   !   -       -
-      REAL(wp)  ::   ztmelts, zdv, zqold, zfrazb, zweight, zalphai, zindb, zde  ! local scalars
+      INTEGER  ::   ji,jj,jk,jl,jm   ! dummy loop indices
+      INTEGER  ::   layer, nbpac     ! local integers 
+      INTEGER  ::   zji, zjj, iter   !   -       -
+      REAL(wp) ::   ztmelts, zdv, zqold, zfrazb, zweight, zalphai, zindb, zde   ! local scalars
       REAL(wp) ::   zgamafr, zvfrx, zvgx, ztaux, ztwogp, zf , zhicol_new        !   -      -
       REAL(wp) ::   ztenagm, zvfry, zvgy, ztauy, zvrel2, zfp, zsqcd , zhicrit   !   -      -
+      REAL(wp) ::   zcoef                                                       !   -      -
       LOGICAL  ::   iterate_frazil   ! iterate frazil ice collection thickness
       CHARACTER (len = 15) :: fieldid
@@ -143,9 +145,9 @@
       ! 1) Conservation check and changes in each ice category
       !------------------------------------------------------------------------------!
-      IF ( con_i ) THEN
-         CALL lim_column_sum (jpl, v_i, vt_i_init)
-         CALL lim_column_sum (jpl, v_s, vt_s_init)
-         CALL lim_column_sum_energy (jpl, nlay_i, e_i, et_i_init)
-         CALL lim_column_sum (jpl,   e_s(:,:,1,:) , et_s_init)
+      IF( con_i ) THEN
+         CALL lim_column_sum        ( jpl, v_i          , vt_i_init)
+         CALL lim_column_sum        ( jpl, v_s          , vt_s_init)
+         CALL lim_column_sum_energy ( jpl, nlay_i , e_i , et_i_init)
+         CALL lim_column_sum        ( jpl, e_s(:,:,1,:) , et_s_init)
       ENDIF
 
@@ -158,9 +160,7 @@
                DO ji = 1, jpi
                   !Energy of melting q(S,T) [J.m-3]
-                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / &
-                     MAX( area(ji,jj) * v_i(ji,jj,jl) ,  epsi10 ) * &
-                     nlay_i
-                  zindb      = 1.0-MAX(0.0,SIGN(1.0,-v_i(ji,jj,jl))) !0 if no ice and 1 if yes
-                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl)*unit_fac*zindb
+                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / MAX( area(ji,jj) * v_i(ji,jj,jl) ,  epsi10 ) * nlay_i
+                  zindb = 1._wp - MAX(  0._wp , SIGN( 1._wp , -v_i(ji,jj,jl) )  )   !0 if no ice and 1 if yes
+                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * unit_fac * zindb
                END DO
             END DO
@@ -182,19 +182,15 @@
       ! 
 
-      zvrel(:,:) = 0.0
+      zvrel(:,:) = 0._wp
 
       ! Default new ice thickness 
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            hicol(ji,jj) = hiccrit(1)
-         END DO
-      END DO
-
-      IF (fraz_swi.eq.1.0) THEN
+      hicol(:,:) = hiccrit(1)
+
+      IF( fraz_swi == 1._wp ) THEN
 
          !--------------------
          ! Physical constants
          !--------------------
-         hicol(:,:) = 0.0
+         hicol(:,:) = 0._wp
 
          zhicrit = 0.04 ! frazil ice thickness
@@ -211,8 +207,8 @@
                   !-------------
                   ! C-grid wind stress components
-                  ztaux         = ( utau_ice(ji-1,jj  ) * tmu(ji-1,jj  ) &
-                     &          +   utau_ice(ji  ,jj  ) * tmu(ji  ,jj  ) ) / 2.0
-                  ztauy         = ( vtau_ice(ji  ,jj-1) * tmv(ji  ,jj-1) &
-                     &          +   vtau_ice(ji  ,jj  ) * tmv(ji  ,jj  ) ) / 2.0
+                  ztaux         = ( utau_ice(ji-1,jj  ) * tmu(ji-1,jj  )   &
+                     &          +   utau_ice(ji  ,jj  ) * tmu(ji  ,jj  ) ) * 0.5_wp
+                  ztauy         = ( vtau_ice(ji  ,jj-1) * tmv(ji  ,jj-1)   &
+                     &          +   vtau_ice(ji  ,jj  ) * tmv(ji  ,jj  ) ) * 0.5_wp
                   ! Square root of wind stress
                   ztenagm       =  SQRT( SQRT( ztaux * ztaux + ztauy * ztauy ) )
@@ -228,9 +224,9 @@
                   !-------------------
                   ! C-grid ice velocity
-                  zindb = MAX(0.0, SIGN(1.0, at_i(ji,jj) ))
-                  zvgx  = zindb * ( u_ice(ji-1,jj  ) * tmu(ji-1,jj  ) &
-                     + u_ice(ji,jj    ) * tmu(ji  ,jj  ) ) / 2.0
-                  zvgy  = zindb * ( v_ice(ji  ,jj-1) * tmv(ji  ,jj-1) &
-                     + v_ice(ji,jj    ) * tmv(ji  ,jj  ) ) / 2.0
+                  zindb = MAX(  0._wp, SIGN( 1._wp , at_i(ji,jj) )  )
+                  zvgx  = zindb * (  u_ice(ji-1,jj  ) * tmu(ji-1,jj  )    &
+                     &             + u_ice(ji,jj    ) * tmu(ji  ,jj  )  ) * 0.5_wp
+                  zvgy  = zindb * (  v_ice(ji  ,jj-1) * tmv(ji  ,jj-1)    &
+                     &             + v_ice(ji,jj    ) * tmv(ji  ,jj  )  ) * 0.5_wp
 
                   !-----------------------------------
@@ -238,8 +234,7 @@
                   !-----------------------------------
                   ! absolute relative velocity
-                  zvrel2        = MAX( ( zvfrx - zvgx ) * ( zvfrx - zvgx ) + &
-                     ( zvfry - zvgy ) * ( zvfry - zvgy )   &
-                     , 0.15 * 0.15 )
-                  zvrel(ji,jj)  = SQRT(zvrel2)
+                  zvrel2 = MAX(  ( zvfrx - zvgx ) * ( zvfrx - zvgx )   &
+                     &         + ( zvfry - zvgy ) * ( zvfry - zvgy ) , 0.15 * 0.15 )
+                  zvrel(ji,jj)  = SQRT( zvrel2 )
 
                   !---------------------
@@ -247,7 +242,12 @@
                   !---------------------
                   hicol(ji,jj) = zhicrit + 0.1 
-                  hicol(ji,jj) = zhicrit + hicol(ji,jj) /      & 
-                     ( hicol(ji,jj) * hicol(ji,jj) - &
-                     zhicrit * zhicrit ) * ztwogp * zvrel2
+                  hicol(ji,jj) = zhicrit +   hicol(ji,jj)    &
+                     &                   / ( hicol(ji,jj) * hicol(ji,jj) -  zhicrit * zhicrit ) * ztwogp * zvrel2
+
+!!gm better coding: above: hicol(ji,jj) * hicol(ji,jj) = (zhicrit + 0.1)*(zhicrit + 0.1)
+!!gm                                                   = zhicrit**2 + 0.2*zhicrit +0.01
+!!gm                therefore the 2 lines with hicol can be replaced by 1 line:
+!!gm              hicol(ji,jj) = zhicrit + (zhicrit + 0.1) / ( 0.2 * zhicrit + 0.01 ) * ztwogp * zvrel2
+!!gm further more (zhicrit + 0.1)/(0.2 * zhicrit + 0.01 )*ztwogp can be computed one for all outside the DO loop
 
                   iter = 1
@@ -284,17 +284,13 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF ( tms(ji,jj) * ( qcmif(ji,jj) - qldif(ji,jj) ) > 0.e0 ) THEN
+            IF ( tms(ji,jj) * ( qcmif(ji,jj) - qldif(ji,jj) )  >  0._wp ) THEN
                nbpac = nbpac + 1
                npac( nbpac ) = (jj - 1) * jpi + ji
-               IF ( (ji.eq.jiindx).AND.(jj.eq.jjindx) ) THEN
-                  jiindex_1d = nbpac
-               ENDIF
+               IF( ji == jiindx .AND. jj == jjindx )   jiindex_1d = nbpac
             ENDIF
          END DO
       END DO
 
-      IF( ln_nicep ) THEN
-         WRITE(numout,*) 'lim_thd_lac : nbpac = ', nbpac
-      ENDIF
+      IF( ln_nicep )   WRITE(numout,*) 'lim_thd_lac : nbpac = ', nbpac
 
       !------------------------------
@@ -306,33 +302,22 @@
       IF ( nbpac > 0 ) THEN
 
-         CALL tab_2d_1d( nbpac, zat_i_ac  (1:nbpac)     , at_i         ,       &
-            jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, zat_i_ac  (1:nbpac)     , at_i         , jpi, jpj, npac(1:nbpac) )
          DO jl = 1, jpl
-            CALL tab_2d_1d( nbpac, za_i_ac(1:nbpac,jl)  , a_i(:,:,jl)  ,       &
-               jpi, jpj, npac(1:nbpac) )
-            CALL tab_2d_1d( nbpac, zv_i_ac(1:nbpac,jl)  , v_i(:,:,jl)  ,       &
-               jpi, jpj, npac(1:nbpac) )
-            CALL tab_2d_1d( nbpac, zoa_i_ac(1:nbpac,jl) , oa_i(:,:,jl) ,       &
-               jpi, jpj, npac(1:nbpac) )
-            CALL tab_2d_1d( nbpac, zsmv_i_ac(1:nbpac,jl), smv_i(:,:,jl),       &
-               jpi, jpj, npac(1:nbpac) )
+            CALL tab_2d_1d( nbpac, za_i_ac  (1:nbpac,jl), a_i  (:,:,jl), jpi, jpj, npac(1:nbpac) )
+            CALL tab_2d_1d( nbpac, zv_i_ac  (1:nbpac,jl), v_i  (:,:,jl), jpi, jpj, npac(1:nbpac) )
+            CALL tab_2d_1d( nbpac, zoa_i_ac (1:nbpac,jl), oa_i (:,:,jl), jpi, jpj, npac(1:nbpac) )
+            CALL tab_2d_1d( nbpac, zsmv_i_ac(1:nbpac,jl), smv_i(:,:,jl), jpi, jpj, npac(1:nbpac) )
             DO jk = 1, nlay_i
-               CALL tab_2d_1d( nbpac, ze_i_ac(1:nbpac,jk,jl), e_i(:,:,jk,jl) , &
-                  jpi, jpj, npac(1:nbpac) )
+               CALL tab_2d_1d( nbpac, ze_i_ac(1:nbpac,jk,jl), e_i(:,:,jk,jl) , jpi, jpj, npac(1:nbpac) )
             END DO ! jk
          END DO ! jl
 
-         CALL tab_2d_1d( nbpac, qldif_1d  (1:nbpac)     , qldif ,              &
-            jpi, jpj, npac(1:nbpac) )
-         CALL tab_2d_1d( nbpac, qcmif_1d  (1:nbpac)     , qcmif ,              &
-            jpi, jpj, npac(1:nbpac) )
-         CALL tab_2d_1d( nbpac, t_bo_b    (1:nbpac)     , t_bo  ,              &
-            jpi, jpj, npac(1:nbpac) )
-         CALL tab_2d_1d( nbpac, fseqv_1d  (1:nbpac)     , fseqv ,              &
-            jpi, jpj, npac(1:nbpac) )
-         CALL tab_2d_1d( nbpac, hicol_b   (1:nbpac)     , hicol ,              &
-            jpi, jpj, npac(1:nbpac) )
-         CALL tab_2d_1d( nbpac, zvrel_ac  (1:nbpac)     , zvrel ,              &
-            jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, qldif_1d  (1:nbpac)     , qldif  , jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, qcmif_1d  (1:nbpac)     , qcmif  , jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, t_bo_b    (1:nbpac)     , t_bo   , jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, sfx_thd_1d(1:nbpac)     , sfx_thd, jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, rdm_ice_1d(1:nbpac)     , rdm_ice, jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, hicol_b   (1:nbpac)     , hicol  , jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, zvrel_ac  (1:nbpac)     , zvrel  , jpi, jpj, npac(1:nbpac) )
 
          !------------------------------------------------------------------------------!
@@ -344,7 +329,7 @@
          !----------------------
          DO ji = 1, nbpac
-            zh_newice(ji)     = hiccrit(1)
-         END DO
-         IF ( fraz_swi .EQ. 1.0 ) zh_newice(:) = hicol_b(:)
+            zh_newice(ji) = hiccrit(1)
+         END DO
+         IF( fraz_swi == 1.0 )   zh_newice(:) = hicol_b(:)
 
          !----------------------
@@ -352,22 +337,17 @@
          !----------------------
 
-         IF ( num_sal .EQ. 1 ) THEN
-            zs_newice(:)      =   bulk_sal
-         ENDIF ! num_sal
-
-         IF ( ( num_sal .EQ. 2 ) .OR. ( num_sal .EQ. 4 ) ) THEN
-
-            DO ji = 1, nbpac
-               zs_newice(ji)  =   MIN( 4.606 + 0.91 / zh_newice(ji) , s_i_max )
-               zji            =   MOD( npac(ji) - 1, jpi ) + 1
-               zjj            =   ( npac(ji) - 1 ) / jpi + 1
-               zs_newice(ji)  =   MIN( 0.5*sss_m(zji,zjj) , zs_newice(ji) )
-            END DO ! jl
-
-         ENDIF ! num_sal
-
-         IF ( num_sal .EQ. 3 ) THEN
-            zs_newice(:)      =   2.3
-         ENDIF ! num_sal
+         SELECT CASE ( num_sal )
+         CASE ( 1 )                    ! Sice = constant 
+            zs_newice(:) = bulk_sal
+         CASE ( 2 )                    ! Sice = F(z,t) [Vancoppenolle et al (2005)]
+            DO ji = 1, nbpac
+               zji =   MOD( npac(ji) - 1 , jpi ) + 1
+               zjj =      ( npac(ji) - 1 ) / jpi + 1
+               zs_newice(ji) = MIN(  4.606 + 0.91 / zh_newice(ji) , s_i_max , 0.5 * sss_m(zji,zjj)  )
+            END DO
+         CASE ( 3 )                    ! Sice = F(z) [multiyear ice]
+            zs_newice(:) =   2.3
+         END SELECT
+
 
          !-------------------------
@@ -376,12 +356,10 @@
          ! We assume that new ice is formed at the seawater freezing point
          DO ji = 1, nbpac
-            ztmelts           = - tmut * zs_newice(ji) + rtt ! Melting point (K)
-            ze_newice(ji)     =   rhoic * ( cpic * ( ztmelts - t_bo_b(ji) )    &
-               + lfus * ( 1.0 - ( ztmelts - rtt )   &
-               / ( t_bo_b(ji) - rtt ) )           &
-               - rcp * ( ztmelts-rtt ) )
-            ze_newice(ji)     =   MAX( ze_newice(ji) , 0.0 ) +                 &
-               MAX( 0.0 , SIGN( 1.0 , - ze_newice(ji) ) )   & 
-               * rhoic * lfus
+            ztmelts       = - tmut * zs_newice(ji) + rtt                  ! Melting point (K)
+            ze_newice(ji) =   rhoic * (  cpic * ( ztmelts - t_bo_b(ji) )                             &
+               &                       + lfus * ( 1.0 - ( ztmelts - rtt ) / ( t_bo_b(ji) - rtt ) )   &
+               &                       - rcp  *         ( ztmelts - rtt )  )
+            ze_newice(ji) =   MAX( ze_newice(ji) , 0._wp )    &
+               &          +   MAX(  0.0 , SIGN( 1.0 , - ze_newice(ji) )  ) * rhoic * lfus
          END DO ! ji
          !----------------
@@ -389,5 +367,5 @@
          !----------------
          DO ji = 1, nbpac
-            zo_newice(ji)     = 0.0
+            zo_newice(ji) = 0._wp
          END DO ! ji
 
@@ -396,5 +374,5 @@
          !--------------------------
          DO ji = 1, nbpac
-            zqbgow(ji)        = qldif_1d(ji) - qcmif_1d(ji) !<0
+            zqbgow(ji) = qldif_1d(ji) - qcmif_1d(ji)     !<0
          END DO ! ji
 
@@ -403,10 +381,9 @@
          !-------------------
          DO ji = 1, nbpac
-            zv_newice(ji)     = - zqbgow(ji) / ze_newice(ji)
+            zv_newice(ji) = - zqbgow(ji) / ze_newice(ji)
 
             ! A fraction zfrazb of frazil ice is accreted at the ice bottom
-            zfrazb        = ( TANH ( Cfrazb * ( zvrel_ac(ji) - vfrazb ) )     & 
-               + 1.0 ) / 2.0 * maxfrazb
-            zdh_frazb(ji) = zfrazb*zv_newice(ji)
+            zfrazb        = ( TANH ( Cfrazb * ( zvrel_ac(ji) - vfrazb ) ) + 1.0 ) * 0.5 * maxfrazb
+            zdh_frazb(ji) =         zfrazb   * zv_newice(ji)
             zv_newice(ji) = ( 1.0 - zfrazb ) * zv_newice(ji)
          END DO
@@ -415,21 +392,9 @@
          ! Salt flux due to new ice growth
          !---------------------------------
-         IF ( ( num_sal .EQ. 4 ) ) THEN 
-            DO ji = 1, nbpac
-               zji            = MOD( npac(ji) - 1, jpi ) + 1
-               zjj            = ( npac(ji) - 1 ) / jpi + 1
-               fseqv_1d(ji)   = fseqv_1d(ji) +                                     &
-                  ( sss_m(zji,zjj) - bulk_sal      ) * rhoic *       &
-                  zv_newice(ji) / rdt_ice
-            END DO
-         ELSE
-            DO ji = 1, nbpac
-               zji            = MOD( npac(ji) - 1, jpi ) + 1
-               zjj            = ( npac(ji) - 1 ) / jpi + 1
-               fseqv_1d(ji)   = fseqv_1d(ji) +                                     &
-                  ( sss_m(zji,zjj) - zs_newice(ji) ) * rhoic *       &
-                  zv_newice(ji) / rdt_ice
-            END DO ! ji
-         ENDIF
+         ! note that for constant salinity zs_newice() = bulk_sal (see top of the subroutine)
+         DO ji = 1, nbpac
+            sfx_thd_1d(ji) = sfx_thd_1d(ji) - zs_newice(ji) * rhoic * zv_newice(ji) * r1_rdtice
+            rdm_ice_1d(ji) = rdm_ice_1d(ji) +                 rhoic * zv_newice(ji)
+         END DO ! ji
 
          !------------------------------------
@@ -437,17 +402,16 @@
          !------------------------------------
          DO ji = 1, nbpac
-            ! Volume
-            zji                  = MOD( npac(ji) - 1, jpi ) + 1
-            zjj                  = ( npac(ji) - 1 ) / jpi + 1
-            vt_i_init(zji,zjj)   = vt_i_init(zji,zjj) + zv_newice(ji)
-            ! Energy
-            zde                  = ze_newice(ji) / unit_fac
-            zde                  = zde * area(zji,zjj) * zv_newice(ji)
-            et_i_init(zji,zjj)   = et_i_init(zji,zjj) + zde
+            zji = MOD( npac(ji) - 1 , jpi ) + 1
+            zjj =    ( npac(ji) - 1 ) / jpi + 1
+            !
+            zde = ze_newice(ji) / unit_fac * area(zji,zjj) * zv_newice(ji)
+            !
+            vt_i_init(zji,zjj) = vt_i_init(zji,zjj) + zv_newice(ji)             ! volume
+            et_i_init(zji,zjj) = et_i_init(zji,zjj) + zde                       ! Energy
+
          END DO
 
          ! keep new ice volume in memory
-         CALL tab_1d_2d( nbpac, v_newice , npac(1:nbpac), zv_newice(1:nbpac) , &
-            jpi, jpj )
+         CALL tab_1d_2d( nbpac, v_newice , npac(1:nbpac), zv_newice(1:nbpac) , jpi, jpj )
 
          !-----------------
@@ -455,9 +419,8 @@
          !-----------------
          DO ji = 1, nbpac
-            za_newice(ji)     = zv_newice(ji) / zh_newice(ji)
-            ! diagnostic
-            zji                  = MOD( npac(ji) - 1, jpi ) + 1
-            zjj                  = ( npac(ji) - 1 ) / jpi + 1
-            diag_lat_gr(zji,zjj) = zv_newice(ji) / rdt_ice
+            zji = MOD( npac(ji) - 1 , jpi ) + 1
+            zjj =    ( npac(ji) - 1 ) / jpi + 1
+            za_newice(ji) = zv_newice(ji) / zh_newice(ji)
+            diag_lat_gr(zji,zjj) = zv_newice(ji) * r1_rdtice
          END DO !ji
 
@@ -476,16 +439,14 @@
          !-------------------------------------------
          ! If lateral ice growth gives an ice concentration gt 1, then
-         ! we keep the excessive volume in memory and attribute it later
-         ! to bottom accretion
-         DO ji = 1, nbpac
-            ! vectorize
-            IF ( za_newice(ji) .GT. ( 1.0 - zat_i_ac(ji) ) ) THEN
-               zda_res(ji)    = za_newice(ji) - (1.0 - zat_i_ac(ji) )
-               zdv_res(ji)    = zda_res(ji) * zh_newice(ji) 
-               za_newice(ji)  = za_newice(ji) - zda_res(ji)
-               zv_newice(ji)  = zv_newice(ji) - zdv_res(ji)
+         ! we keep the excessive volume in memory and attribute it later to bottom accretion
+         DO ji = 1, nbpac
+            IF ( za_newice(ji)  >  ( 1._wp - zat_i_ac(ji) ) ) THEN
+               zda_res(ji)   = za_newice(ji) - (1.0 - zat_i_ac(ji) )
+               zdv_res(ji)   = zda_res  (ji) * zh_newice(ji) 
+               za_newice(ji) = za_newice(ji) - zda_res  (ji)
+               zv_newice(ji) = zv_newice(ji) - zdv_res  (ji)
             ELSE
-               zda_res(ji) = 0.0
-               zdv_res(ji) = 0.0
+               zda_res(ji) = 0._wp
+               zdv_res(ji) = 0._wp
             ENDIF
          END DO ! ji
@@ -497,6 +458,6 @@
          DO jl = 1, jpl
             DO ji = 1, nbpac
-               IF(  hi_max   (jl-1)  <  zh_newice(ji)   .AND.   &
-                  & zh_newice(ji)    <= hi_max   (jl)         ) THEN
+               IF(  hi_max   (jl-1)  <   zh_newice(ji)   .AND.   &
+                  & zh_newice(ji)    <=  hi_max   (jl)         ) THEN
                   za_i_ac (ji,jl) = za_i_ac (ji,jl) + za_newice(ji)
                   zv_i_ac (ji,jl) = zv_i_ac (ji,jl) + zv_newice(ji)
@@ -504,6 +465,6 @@
                   zcatac  (ji)    = jl
                ENDIF
-            END DO ! ji
-         END DO ! jl
+            END DO
+         END DO
 
          !----------------------------------
@@ -521,5 +482,5 @@
             DO ji = 1, nbpac
                jl = zcatac(ji)
-               zqold   = ze_i_ac(ji,jk,jl) ! [ J.m-3 ]
+               zqold   = ze_i_ac(ji,jk,jl)      ! [ J.m-3 ]
                zalphai = MIN( zhice_old(ji,jl) *   jk       / nlay_i , zh_newice(ji) )   &
                   &    - MIN( zhice_old(ji,jl) * ( jk - 1 ) / nlay_i , zh_newice(ji) )
@@ -527,5 +488,5 @@
                   + ( 1.0 - zswinew(ji) ) * ( za_old(ji,jl)  * zqold * zhice_old(ji,jl) / nlay_i   &
                   + za_newice(ji)  * ze_newice(ji) * zalphai                                       &
-                  + za_newice(ji)  * ze_newice(ji) * zdhex(ji) / nlay_i ) / ( ( zv_i_ac(ji,jl) ) / nlay_i )
+                  + za_newice(ji)  * ze_newice(ji) * zdhex(ji) / nlay_i ) / ( zv_i_ac(ji,jl) / nlay_i )
             END DO
          END DO
@@ -567,5 +528,5 @@
                zdhicbot (ji,jl) = zdv_res(ji)    / MAX( za_i_ac(ji,jl) , epsi10 ) * zindb    &
                   &             +  zindb * zdh_frazb(ji)                               ! frazil ice may coalesce
-               zdummy(ji,jl)    = zv_i_ac(ji,jl)/MAX(za_i_ac(ji,jl),epsi10)*zindb      ! thickness of residual ice
+               zdummy(ji,jl)    = zv_i_ac(ji,jl) / MAX( za_i_ac(ji,jl) , epsi10 ) * zindb      ! thickness of residual ice
             END DO
          END DO
@@ -628,8 +589,8 @@
          ! Update salinity
          !-----------------
-         IF(  num_sal == 2  .OR.  num_sal == 4  ) THEN
+         IF(  num_sal == 2  ) THEN      ! Sice = F(z,t)
             DO jl = 1, jpl
                DO ji = 1, nbpac
-                  zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , - zv_i_ac(ji,jl) ) )  ! 0 if no ice and 1 if yes
+                  zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , - zv_i_ac(ji,jl) ) )   ! 0 if no ice and 1 if yes
                   zdv   = zv_i_ac(ji,jl) - zv_old(ji,jl)
                   zsmv_i_ac(ji,jl) = ( zsmv_i_ac(ji,jl) + zdv * zs_newice(ji) ) * zindb
@@ -645,5 +606,5 @@
             CALL tab_1d_2d( nbpac, v_i (:,:,jl), npac(1:nbpac), zv_i_ac (1:nbpac,jl), jpi, jpj )
             CALL tab_1d_2d( nbpac, oa_i(:,:,jl), npac(1:nbpac), zoa_i_ac(1:nbpac,jl), jpi, jpj )
-            IF (  num_sal == 2  .OR.  num_sal == 4  )   &
+            IF (  num_sal == 2  )   &
                CALL tab_1d_2d( nbpac, smv_i (:,:,jl), npac(1:nbpac), zsmv_i_ac(1:nbpac,jl) , jpi, jpj )
             DO jk = 1, nlay_i
@@ -651,5 +612,6 @@
             END DO
          END DO
-         CALL tab_1d_2d( nbpac, fseqv , npac(1:nbpac), fseqv_1d  (1:nbpac) , jpi, jpj )
+         CALL tab_1d_2d( nbpac, sfx_thd, npac(1:nbpac), sfx_thd_1d(1:nbpac), jpi, jpj )
+         CALL tab_1d_2d( nbpac, rdm_ice, npac(1:nbpac), rdm_ice_1d(1:nbpac), jpi, jpj )
          !
       ENDIF ! nbpac > 0
@@ -660,5 +622,5 @@
       DO jl = 1, jpl
          DO jk = 1, nlay_i          ! heat content in 10^9 Joules
-            e_i(:,:,jk,jl) = e_i(:,:,jk,jl) * area(:,:) * v_i(:,:,jl) / nlay_i  / unit_fac 
+            e_i(:,:,jk,jl) = e_i(:,:,jk,jl) * area(:,:) * v_i(:,:,jl) / nlay_i / unit_fac 
          END DO
       END DO
